/* Botanical first started with a very simple design followed from the book. I didn't know about the intro
of randomness yet so this was really just a test to understand the popping and pushing of the turtles.

*/

class Botanical{
 String axiom;
 String computedWord;
 //String[][] sqRules = {{"F", "F-F-F-F+"}};
 String[][] rules = {{"X", "F[-XFX][+XFX]"},{"F","FF"},{"+","+"},{"-","-"},
{"[", "["}, {"]","]"},};
 float size, angle;
 
Botanical(float size, float angle){
   this.size = size;
   this.angle = angle;
   axiom = "GF[+FFX]F[-X][FX]FXFX";
   computedWord = axiom;
   
}

void iterate(int iterations){
 String tempWord;
 //println(computedWord);
 tempWord = computedWord;
 for(int i = 0; i < iterations; i++){
   tempWord = computedWord;
   computedWord = "";
   for(int j = 0; j <tempWord.length(); j++){
      char c = tempWord.charAt(j);
      for(int k = 0; k < rules.length; k++){
       if( c == rules[k][0].charAt(0)){
            computedWord = computedWord + rules[k][1];
            break;
       }
      }
   }
  // println("itearation" + i + ":" + computedWord);
 }
    println(computedWord);
}


void drawLSystem(Turtle t){
  t.penUp();
  t.back(height/2 - 10);
  t.penDown();
 for(int i = 0; i <computedWord.length(); i++){
   char c = computedWord.charAt(i);
  if(c == 'F')
   t.forward(size); 
   else if(c == 'L')
   t.forward(size);
   else if(c == 'R')
   t.forward(size);
   else if(c == '+')
    t.right(angle);
   else if(c == '-')
    t.left(angle);
   else if(c == '[')
     t.push();
   else if(c == ']')
     t.pop();
   else if(c == 'G')
   for(int s = 0; s < 360; s += 20)
     t.right(20);
     t.forward(10);
     t.back(10);
   
 }
}
}
