/*****************************************
 * Large Assignment 1: Laser Cut L-Systems
 * Name:    Marcos Lopez
 * E-mail:  Marctlopez@salud.unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    2/14/2022
 *
 * This program includes several different L-Systems and designs.
 * Click the mouse to run through some example designs.
***********************************************/

import Turtle.*;
import processing.pdf.*;
Turtle t;
int n;

void setup(){
 size(1920,1080);
 background(100,100,0);
 print("hello");
 n = 0;
 
}
// will run through the different types of L-System or designs. 
void mouseClicked(){
 print("hello");
 background(255);
 stroke(0);
 if (n == 0){
   Botanical_Better a = new Botanical_Better(5,15);
   a.iterate(6);
   t = new Turtle(this);
   a.drawLSystem(t);
 }
 if (n == 1){
    lsystem l = new lsystem(8,90);
    l.iterate(6);
    t = new Turtle(this);
    l.drawLSystem(t);
 }
 if (n == 2){
   t = new Turtle(this);
   attempt2(t);
 }
 if (n == 3){
   background(0);
   t = new Turtle(this);
   Shapes s = new Shapes(20, 45);
   s.iterate(3);
   s.drawLSystem(t);
   n = -1;
 }

 n++;
}

void draw(){
  
}
