class lsystem{
 String axiom;
 String computedWord;
 //String[][] sqRules = {{"F", "F-F-F-F+"}};
 String[][] rules = {{"L", "R+LL+R"},{"R", "R-L-R"},{"+","+"},{"-","-"},
 {"F", "F"}};
 float size, angle;
 
 lsystem(float size, float angle){
   this.size = size;
   this.angle = angle;
   axiom = "+R+R-LL-L+R+R";
   computedWord = axiom;
   
}

void iterate(int iterations){
 String tempWord;
 //println(computedWord);
 tempWord = computedWord;
 for(int i = 0; i < iterations; i++){
   tempWord = computedWord;
   computedWord = "";
   for(int j = 0; j <tempWord.length(); j++){
      char c = tempWord.charAt(j);
      for(int k = 0; k < rules.length; k++){
       if( c == rules[k][0].charAt(0)){
            computedWord = computedWord + rules[k][1];
            break;
       }
      }
   }
  // println("itearation" + i + ":" + computedWord);
 }
  
}


void drawLSystem(Turtle t){
 for(int i = 0; i <computedWord.length(); i++){
   char c = computedWord.charAt(i);
  if(c == 'F')
   t.forward(size); 
   else if(c == 'L')
   t.forward(size);
   else if(c == 'R')
   t.forward(size);
  else if(c == '+')
    t.right(angle);
  else if(c == '-')
    t.left(angle);
 }
  
}
}
