/* The hardest to start but my favorite by far. I started thinking about what kind of shapes could I 
use with L-Systems and it just didnt make me happy working with pieces and turtles to make shapes. Then
I thought lets just go to the basics and use the things I already know. Squares and Circles. Then instead
of working with the turtle to make the shapes I will use the turtle to get into a position where the squares and circles will be drawn
I loved this part the most. BY FAR. Still follows the same LSystem code so only the few changes will be commented.

*/

class Shapes{
 String axiom;
 String computedWord;
 //String[][] sqRules = {{"F", "F-F-F-F+"}};
 String[][] rules = {{"L", "R+LF+R"},{"R", "R-LL-R"},{"+","+"},{"-","-"},
 {"F", "FF"}};
 float size, angle;
 
 Shapes(float size, float angle){
   this.size = size;
   this.angle = angle;
   axiom = "R+L+R";
   computedWord = axiom;
   
}

void iterate(int iterations){
 String tempWord;
 //println(computedWord);
 tempWord = computedWord;
 for(int i = 0; i < iterations; i++){
   tempWord = computedWord;
   computedWord = "";
   for(int j = 0; j <tempWord.length(); j++){
      char c = tempWord.charAt(j);
      for(int k = 0; k < rules.length; k++){
       if( c == rules[k][0].charAt(0)){
            computedWord = computedWord + rules[k][1];
            break;
       }
      }
   }
  // println("itearation" + i + ":" + computedWord);
 }
  
}


void drawLSystem(Turtle t){
  //pen up so we dont see the turtle. Can make really cool designs with it down however.
 t.penUp();
 for(int i = 0; i <computedWord.length(); i++){
   char c = computedWord.charAt(i);
  if(c == 'F')
   t.forward(size); 
   else if(c == 'L'){
   fill(random(255),random(255),random(255));
   t.forward(size);
   circle(t.getX(),t.getY(), random(size));
   }
   else if(c == 'R'){
 //    fill(255);
   t.forward(size);
   square(t.getX(),t.getY(), size/2);
   }
  else if(c == '+')
    t.right(angle);
  else if(c == '-')
    t.left(angle);
 }
  
}
}
